import { IMultinameInfo } from "./multiname";
export declare enum InstructionCode {
    add = 160,
    add_i = 197,
    astype = 134,
    astypelate = 135,
    bitand = 168,
    bitnot = 151,
    bitor = 169,
    bitxor = 170,
    call = 65,
    callmethod = 67,
    callproperty = 70,
    callproplex = 76,
    callpropvoid = 79,
    callstatic = 68,
    callsuper = 69,
    callsupervoid = 78,
    checkfilter = 120,
    coerce = 128,
    coerce_a = 130,
    coerce_s = 133,
    construct = 66,
    contructprop = 74,
    constructsuper = 73,
    convert_b = 118,
    convert_i = 115,
    convert_d = 117,
    convert_o = 119,
    convert_u = 116,
    convert_s = 112,
    debug = 239,
    debugfile = 241,
    debugline = 240,
    declocal = 148,
    declocal_i = 195,
    decrement = 147,
    decrement_i = 193,
    deleteproperty = 106,
    divide = 163,
    dup = 42,
    dxns = 6,
    dxnslate = 7,
    equals = 171,
    esc_xattr = 114,
    esc_xelem = 113,
    findproperty = 94,
    findpropstrict = 93,
    getdescendants = 89,
    getglobalscope = 100,
    getglobalslot = 110,
    getlex = 96,
    getlocal = 98,
    getlocal_0 = 208,
    getlocal_1 = 209,
    getlocal_2 = 210,
    getlocal_3 = 211,
    getproperty = 102,
    getscopeobject = 101,
    getslot = 108,
    getsuper = 4,
    greaterequals = 176,
    greaterthan = 175,
    hasnext = 31,
    hasnext2 = 50,
    ifeq = 19,
    iffalse = 18,
    ifge = 24,
    ifgt = 23,
    ifle = 22,
    iflt = 21,
    ifnge = 15,
    ifngt = 14,
    ifnle = 13,
    ifnlt = 12,
    ifne = 20,
    ifstricteq = 25,
    ifstrictne = 26,
    iftrue = 17,
    in = 180,
    inclocal = 146,
    inclocal_i = 194,
    increment = 145,
    increment_i = 192,
    initproperty = 104,
    instanceof = 177,
    istype = 178,
    istypelate = 179,
    jump = 16,
    kill = 8,
    label = 9,
    lessequals = 174,
    lessthan = 173,
    lookupswitch = 27,
    lshift = 165,
    modulo = 164,
    multiply = 162,
    multiply_i = 199,
    negate = 144,
    negate_i = 196,
    newactivation = 87,
    newarray = 86,
    newcatch = 90,
    newclass = 88,
    newfunction = 64,
    newobject = 85,
    nextname = 30,
    nextvalue = 35,
    nop = 2,
    not = 150,
    pop = 41,
    popscope = 29,
    pushbyte = 36,
    pushdouble = 47,
    pushfalse = 39,
    pushint = 45,
    pushnamespace = 49,
    pushnan = 40,
    pushnull = 32,
    pushscope = 48,
    pushshort = 37,
    pushstring = 44,
    pushtrue = 38,
    pushuint = 46,
    undefined = 33,
    pushwith = 28,
    returnvalue = 72,
    returnvoid = 71,
    rshift = 166,
    setlocal = 99,
    setlocal_0 = 212,
    setlocal_1 = 213,
    setlocal_2 = 214,
    setlocal_3 = 215,
    setglobalslot = 111,
    setproperty = 97,
    setslot = 109,
    setsuper = 5,
    strictequals = 172,
    subtract = 161,
    subtract_i = 198,
    swap = 43,
    throw = 3,
    typeof = 149,
    urshift = 167,
    applytype = 83,
    bkpt = 1,
    lf32 = 56,
    lf64 = 57,
    li16 = 54,
    li32 = 55,
    li8 = 53,
    sf32 = 61,
    sf64 = 62,
    si16 = 59,
    si32 = 60,
    si8 = 58,
    sxi1 = 80,
    sxi16 = 82,
    sxi8 = 81
}
export interface IInstruction {
    code: InstructionCode;
    byteOffset?: number;
}
export interface ISxi1Instr extends IInstruction {
    code: InstructionCode.sxi1;
}
export interface ISxi16Instr extends IInstruction {
    code: InstructionCode.sxi16;
}
export interface ISxi8Instr extends IInstruction {
    code: InstructionCode.sxi8;
}
export interface ISf32Instr extends IInstruction {
    code: InstructionCode.sf32;
}
export interface ISf64Instr extends IInstruction {
    code: InstructionCode.sf64;
}
export interface ISi16Instr extends IInstruction {
    code: InstructionCode.si16;
}
export interface ISi32Instr extends IInstruction {
    code: InstructionCode.si32;
}
export interface ISi8Instr extends IInstruction {
    code: InstructionCode.si8;
}
export interface ILf32Instr extends IInstruction {
    code: InstructionCode.lf32;
}
export interface ILf64Instr extends IInstruction {
    code: InstructionCode.lf64;
}
export interface ILi16Instr extends IInstruction {
    code: InstructionCode.li16;
}
export interface ILi32Instr extends IInstruction {
    code: InstructionCode.li32;
}
export interface ILi8Instr extends IInstruction {
    code: InstructionCode.li8;
}
export interface IBkptInstr extends IInstruction {
    code: InstructionCode.bkpt;
}
export interface IApplytypeInstr extends IInstruction {
    code: InstructionCode.applytype;
}
export interface IAddInstr extends IInstruction {
    code: InstructionCode.add;
}
export interface IAddIInstr extends IInstruction {
    code: InstructionCode.add_i;
}
export interface IAstypeInstr extends IInstruction {
    code: InstructionCode.astype;
    operand0: number;
}
export interface IAstypelateInstr extends IInstruction {
    code: InstructionCode.astypelate;
}
export interface IBitandInstr extends IInstruction {
    code: InstructionCode.bitand;
}
export interface IBitnotInstr extends IInstruction {
    code: InstructionCode.bitnot;
}
export interface IBitorInstr extends IInstruction {
    code: InstructionCode.bitor;
}
export interface IBitxorInstr extends IInstruction {
    code: InstructionCode.bitxor;
}
export interface ICallInstr extends IInstruction {
    code: InstructionCode.call;
    operand0: number;
}
export interface ICallmethodInstr extends IInstruction {
    code: InstructionCode.callmethod;
    operand0: number;
    operand1: number;
}
export interface ICallpropertyInstr extends IInstruction {
    code: InstructionCode.callproperty;
    name: IMultinameInfo;
    argCount: number;
}
export interface ICallproplexInstr extends IInstruction {
    code: InstructionCode.callproplex;
    operand0: number;
    operand1: number;
}
export interface ICallpropvoidInstr extends IInstruction {
    code: InstructionCode.callpropvoid;
    name: IMultinameInfo;
    argCount: number;
}
export interface ICallstaticInstr extends IInstruction {
    code: InstructionCode.callstatic;
    operand0: number;
    operand1: number;
}
export interface ICallsuperInstr extends IInstruction {
    code: InstructionCode.callsuper;
    operand0: number;
    operand1: number;
}
export interface ICallsupervoidInstr extends IInstruction {
    code: InstructionCode.callsupervoid;
    operand0: number;
    operand1: number;
}
export interface ICheckfilterInstr extends IInstruction {
    code: InstructionCode.checkfilter;
}
export interface ICoerceInstr extends IInstruction {
    code: InstructionCode.coerce;
    operand0: number;
}
export interface ICoerceAInstr extends IInstruction {
    code: InstructionCode.coerce_a;
}
export interface ICoerceSInstr extends IInstruction {
    code: InstructionCode.coerce_s;
}
export interface IConstructInstr extends IInstruction {
    code: InstructionCode.construct;
    operand0: number;
}
export interface IContructpropInstr extends IInstruction {
    code: InstructionCode.contructprop;
    name: IMultinameInfo;
    argCount: number;
}
export interface IConstructsuperInstr extends IInstruction {
    code: InstructionCode.constructsuper;
    operand0: number;
}
export interface IConvertBInstr extends IInstruction {
    code: InstructionCode.convert_b;
}
export interface IConvertIInstr extends IInstruction {
    code: InstructionCode.convert_i;
}
export interface IConvertDInstr extends IInstruction {
    code: InstructionCode.convert_d;
}
export interface IConvertOInstr extends IInstruction {
    code: InstructionCode.convert_o;
}
export interface IConvertUInstr extends IInstruction {
    code: InstructionCode.convert_u;
}
export interface IConvertSInstr extends IInstruction {
    code: InstructionCode.convert_s;
}
export interface IDebugInstr extends IInstruction {
    code: InstructionCode.debug;
    operand0: number;
    operand1: number;
    operand2: number;
    operand3: number;
}
export interface IDebugfileInstr extends IInstruction {
    code: InstructionCode.debugfile;
    operand0: number;
}
export interface IDebuglineInstr extends IInstruction {
    code: InstructionCode.debugline;
    operand0: number;
}
export interface IDeclocalInstr extends IInstruction {
    code: InstructionCode.declocal;
    operand0: number;
}
export interface IDeclocalIInstr extends IInstruction {
    code: InstructionCode.declocal_i;
    operand0: number;
}
export interface IDecrementInstr extends IInstruction {
    code: InstructionCode.decrement;
}
export interface IDecrementIInstr extends IInstruction {
    code: InstructionCode.decrement_i;
}
export interface IDeletepropertyInstr extends IInstruction {
    code: InstructionCode.deleteproperty;
    operand0: number;
}
export interface IDivideInstr extends IInstruction {
    code: InstructionCode.divide;
}
export interface IDupInstr extends IInstruction {
    code: InstructionCode.dup;
}
export interface IDxnsInstr extends IInstruction {
    code: InstructionCode.dxns;
    operand0: number;
}
export interface IDxnslateInstr extends IInstruction {
    code: InstructionCode.dxnslate;
}
export interface IEqualsInstr extends IInstruction {
    code: InstructionCode.equals;
}
export interface IEscXattrInstr extends IInstruction {
    code: InstructionCode.esc_xattr;
}
export interface IEscXelemInstr extends IInstruction {
    code: InstructionCode.esc_xelem;
}
export interface IFindpropertyInstr extends IInstruction {
    code: InstructionCode.findproperty;
    operand0: number;
}
export interface IFindpropstrictInstr extends IInstruction {
    code: InstructionCode.findpropstrict;
    name: IMultinameInfo;
}
export interface IGetdescendantsInstr extends IInstruction {
    code: InstructionCode.getdescendants;
    operand0: number;
}
export interface IGetglobalscopeInstr extends IInstruction {
    code: InstructionCode.getglobalscope;
}
export interface IGetglobalslotInstr extends IInstruction {
    code: InstructionCode.getglobalslot;
    operand0: number;
}
export interface IGetlexInstr extends IInstruction {
    code: InstructionCode.getlex;
    name: IMultinameInfo;
}
export interface IGetlocalInstr extends IInstruction {
    code: InstructionCode.getlocal;
    index: number;
}
export interface IGetlocal0Instr extends IInstruction {
    code: InstructionCode.getlocal_0;
}
export interface IGetlocal1Instr extends IInstruction {
    code: InstructionCode.getlocal_1;
}
export interface IGetlocal2Instr extends IInstruction {
    code: InstructionCode.getlocal_2;
}
export interface IGetlocal3Instr extends IInstruction {
    code: InstructionCode.getlocal_3;
}
export interface IGetpropertyInstr extends IInstruction {
    code: InstructionCode.getproperty;
    name: IMultinameInfo;
}
export interface IGetscopeobjectInstr extends IInstruction {
    code: InstructionCode.getscopeobject;
    operand0: number;
}
export interface IGetslotInstr extends IInstruction {
    code: InstructionCode.getslot;
    operand0: number;
}
export interface IGetsuperInstr extends IInstruction {
    code: InstructionCode.getsuper;
    operand0: number;
}
export interface IGreaterequalsInstr extends IInstruction {
    code: InstructionCode.greaterequals;
}
export interface IGreaterthanInstr extends IInstruction {
    code: InstructionCode.greaterthan;
}
export interface IHasnextInstr extends IInstruction {
    code: InstructionCode.hasnext;
}
export interface IHasnext2Instr extends IInstruction {
    code: InstructionCode.hasnext2;
    operand0: number;
    operand1: number;
}
export interface IIfeqInstr extends IInstruction {
    code: InstructionCode.ifeq;
    operand0: number;
}
export interface IIffalseInstr extends IInstruction {
    code: InstructionCode.iffalse;
    operand0: number;
}
export interface IIfgeInstr extends IInstruction {
    code: InstructionCode.ifge;
    operand0: number;
}
export interface IIfgtInstr extends IInstruction {
    code: InstructionCode.ifgt;
    operand0: number;
}
export interface IIfleInstr extends IInstruction {
    code: InstructionCode.ifle;
    operand0: number;
}
export interface IIfltInstr extends IInstruction {
    code: InstructionCode.iflt;
    operand0: number;
}
export interface IIfngeInstr extends IInstruction {
    code: InstructionCode.ifnge;
    operand0: number;
}
export interface IIfngtInstr extends IInstruction {
    code: InstructionCode.ifngt;
    operand0: number;
}
export interface IIfnleInstr extends IInstruction {
    code: InstructionCode.ifnle;
    operand0: number;
}
export interface IIfnltInstr extends IInstruction {
    code: InstructionCode.ifnlt;
    offset: number;
}
export interface IIfneInstr extends IInstruction {
    code: InstructionCode.ifne;
    operand0: number;
}
export interface IIfstricteqInstr extends IInstruction {
    code: InstructionCode.ifstricteq;
    operand0: number;
}
export interface IIfstrictneInstr extends IInstruction {
    code: InstructionCode.ifstrictne;
    operand0: number;
}
export interface IIftrueInstr extends IInstruction {
    code: InstructionCode.iftrue;
    operand0: number;
}
export interface IInInstr extends IInstruction {
    code: InstructionCode.in;
}
export interface IInclocalInstr extends IInstruction {
    code: InstructionCode.inclocal;
    operand0: number;
}
export interface IInclocalIInstr extends IInstruction {
    code: InstructionCode.inclocal_i;
    operand0: number;
}
export interface IIncrementInstr extends IInstruction {
    code: InstructionCode.increment;
}
export interface IIncrementIInstr extends IInstruction {
    code: InstructionCode.increment_i;
}
export interface IInitpropertyInstr extends IInstruction {
    code: InstructionCode.initproperty;
    operand0: number;
}
export interface IInstanceofInstr extends IInstruction {
    code: InstructionCode.instanceof;
}
export interface IIstypeInstr extends IInstruction {
    code: InstructionCode.istype;
    operand0: number;
}
export interface IIstypelateInstr extends IInstruction {
    code: InstructionCode.istypelate;
}
export interface IJumpInstr extends IInstruction {
    code: InstructionCode.jump;
    operand0: number;
}
export interface IKillInstr extends IInstruction {
    code: InstructionCode.kill;
    operand0: number;
}
export interface ILabelInstr extends IInstruction {
    code: InstructionCode.label;
}
export interface ILessequalsInstr extends IInstruction {
    code: InstructionCode.lessequals;
}
export interface ILessthanInstr extends IInstruction {
    code: InstructionCode.lessthan;
}
export interface ILookupswitchInstr extends IInstruction {
    code: InstructionCode.lookupswitch;
    operand0: number;
    cases: number[];
}
export interface ILshiftInstr extends IInstruction {
    code: InstructionCode.lshift;
}
export interface IModuloInstr extends IInstruction {
    code: InstructionCode.modulo;
}
export interface IMultiplyInstr extends IInstruction {
    code: InstructionCode.multiply;
}
export interface IMultiplyIInstr extends IInstruction {
    code: InstructionCode.multiply_i;
}
export interface INegateInstr extends IInstruction {
    code: InstructionCode.negate;
}
export interface INegateIInstr extends IInstruction {
    code: InstructionCode.negate_i;
}
export interface INewactivationInstr extends IInstruction {
    code: InstructionCode.newactivation;
}
export interface INewarrayInstr extends IInstruction {
    code: InstructionCode.newarray;
    operand0: number;
}
export interface INewcatchInstr extends IInstruction {
    code: InstructionCode.newcatch;
    operand0: number;
}
export interface INewclassInstr extends IInstruction {
    code: InstructionCode.newclass;
    operand0: number;
}
export interface INewfunctionInstr extends IInstruction {
    code: InstructionCode.newfunction;
    operand0: number;
}
export interface INewobjectInstr extends IInstruction {
    code: InstructionCode.newobject;
    operand0: number;
}
export interface INextnameInstr extends IInstruction {
    code: InstructionCode.nextname;
}
export interface INextvalueInstr extends IInstruction {
    code: InstructionCode.nextvalue;
}
export interface INopInstr extends IInstruction {
    code: InstructionCode.nop;
}
export interface INotInstr extends IInstruction {
    code: InstructionCode.not;
}
export interface IPopInstr extends IInstruction {
    code: InstructionCode.pop;
}
export interface IPopscopeInstr extends IInstruction {
    code: InstructionCode.popscope;
}
export interface IPushbyteInstr extends IInstruction {
    code: InstructionCode.pushbyte;
    byteValue: number;
}
export interface IPushdoubleInstr extends IInstruction {
    code: InstructionCode.pushdouble;
    value: number;
}
export interface IPushfalseInstr extends IInstruction {
    code: InstructionCode.pushfalse;
}
export interface IPushintInstr extends IInstruction {
    code: InstructionCode.pushint;
    operand0: number;
}
export interface IPushnamespaceInstr extends IInstruction {
    code: InstructionCode.pushnamespace;
    operand0: number;
}
export interface IPushnanInstr extends IInstruction {
    code: InstructionCode.pushnan;
}
export interface IPushnullInstr extends IInstruction {
    code: InstructionCode.pushnull;
}
export interface IPushscopeInstr extends IInstruction {
    code: InstructionCode.pushscope;
}
export interface IPushshortInstr extends IInstruction {
    code: InstructionCode.pushshort;
    operand0: number;
}
export interface IPushstringInstr extends IInstruction {
    code: InstructionCode.pushstring;
    value: string;
}
export interface IPushtrueInstr extends IInstruction {
    code: InstructionCode.pushtrue;
}
export interface IPushuintInstr extends IInstruction {
    code: InstructionCode.pushuint;
    operand0: number;
}
export interface IUndefinedInstr extends IInstruction {
    code: InstructionCode.undefined;
}
export interface IPushwithInstr extends IInstruction {
    code: InstructionCode.pushwith;
}
export interface IReturnvalueInstr extends IInstruction {
    code: InstructionCode.returnvalue;
}
export interface IReturnvoidInstr extends IInstruction {
    code: InstructionCode.returnvoid;
}
export interface IRshiftInstr extends IInstruction {
    code: InstructionCode.rshift;
}
export interface ISetlocalInstr extends IInstruction {
    code: InstructionCode.setlocal;
    index: number;
}
export interface ISetlocal0Instr extends IInstruction {
    code: InstructionCode.setlocal_0;
}
export interface ISetlocal1Instr extends IInstruction {
    code: InstructionCode.setlocal_1;
}
export interface ISetlocal2Instr extends IInstruction {
    code: InstructionCode.setlocal_2;
}
export interface ISetlocal3Instr extends IInstruction {
    code: InstructionCode.setlocal_3;
}
export interface ISetglobalslotInstr extends IInstruction {
    code: InstructionCode.setglobalslot;
    operand0: number;
}
export interface ISetpropertyInstr extends IInstruction {
    code: InstructionCode.setproperty;
    operand0: number;
}
export interface ISetslotInstr extends IInstruction {
    code: InstructionCode.setslot;
    operand0: number;
}
export interface ISetsuperInstr extends IInstruction {
    code: InstructionCode.setsuper;
    operand0: number;
}
export interface IStrictequalsInstr extends IInstruction {
    code: InstructionCode.strictequals;
}
export interface ISubtractInstr extends IInstruction {
    code: InstructionCode.subtract;
}
export interface ISubtractIInstr extends IInstruction {
    code: InstructionCode.subtract_i;
}
export interface ISwapInstr extends IInstruction {
    code: InstructionCode.swap;
}
export interface IThrowInstr extends IInstruction {
    code: InstructionCode.throw;
}
export interface ITypeofInstr extends IInstruction {
    code: InstructionCode.typeof;
}
export interface IUrshiftInstr extends IInstruction {
    code: InstructionCode.urshift;
}
export declare type Instruction = ISxi1Instr | ISxi16Instr | ISxi8Instr | ISi8Instr | ISf32Instr | ISf64Instr | ISi16Instr | ISi32Instr | ILf32Instr | ILf64Instr | ILi16Instr | ILi32Instr | ILi8Instr | IBkptInstr | IApplytypeInstr | IAddInstr | IAddIInstr | IAstypeInstr | IAstypelateInstr | IBitandInstr | IBitnotInstr | IBitorInstr | IBitxorInstr | ICallInstr | ICallmethodInstr | ICallpropertyInstr | ICallproplexInstr | ICallpropvoidInstr | ICallstaticInstr | ICallsuperInstr | ICallsupervoidInstr | ICheckfilterInstr | ICoerceInstr | ICoerceAInstr | ICoerceSInstr | IConstructInstr | IContructpropInstr | IConstructsuperInstr | IConvertBInstr | IConvertIInstr | IConvertDInstr | IConvertOInstr | IConvertUInstr | IConvertSInstr | IDebugInstr | IDebugfileInstr | IDebuglineInstr | IDeclocalInstr | IDeclocalIInstr | IDecrementInstr | IDecrementIInstr | IDeletepropertyInstr | IDivideInstr | IDupInstr | IDxnsInstr | IDxnslateInstr | IEqualsInstr | IEscXattrInstr | IEscXelemInstr | IFindpropertyInstr | IFindpropstrictInstr | IGetdescendantsInstr | IGetglobalscopeInstr | IGetglobalslotInstr | IGetlexInstr | IGetlocalInstr | IGetlocal0Instr | IGetlocal1Instr | IGetlocal2Instr | IGetlocal3Instr | IGetpropertyInstr | IGetscopeobjectInstr | IGetslotInstr | IGetsuperInstr | IGreaterequalsInstr | IGreaterthanInstr | IHasnextInstr | IHasnext2Instr | IIfeqInstr | IIffalseInstr | IIfgeInstr | IIfgtInstr | IIfleInstr | IIfltInstr | IIfngeInstr | IIfngtInstr | IIfnleInstr | IIfnltInstr | IIfneInstr | IIfstricteqInstr | IIfstrictneInstr | IIftrueInstr | IInInstr | IInclocalInstr | IInclocalIInstr | IIncrementInstr | IIncrementIInstr | IInitpropertyInstr | IInstanceofInstr | IIstypeInstr | IIstypelateInstr | IJumpInstr | IKillInstr | ILabelInstr | ILessequalsInstr | ILessthanInstr | ILookupswitchInstr | ILshiftInstr | IModuloInstr | IMultiplyInstr | IMultiplyIInstr | INegateInstr | INegateIInstr | INewactivationInstr | INewarrayInstr | INewcatchInstr | INewclassInstr | INewfunctionInstr | INewobjectInstr | INextnameInstr | INextvalueInstr | INopInstr | INotInstr | IPopInstr | IPopscopeInstr | IPushbyteInstr | IPushdoubleInstr | IPushfalseInstr | IPushintInstr | IPushnamespaceInstr | IPushnanInstr | IPushnullInstr | IPushscopeInstr | IPushshortInstr | IPushstringInstr | IPushtrueInstr | IPushuintInstr | IUndefinedInstr | IPushwithInstr | IReturnvalueInstr | IReturnvoidInstr | IRshiftInstr | ISetlocalInstr | ISetlocal0Instr | ISetlocal1Instr | ISetlocal2Instr | ISetlocal3Instr | ISetglobalslotInstr | ISetpropertyInstr | ISetslotInstr | ISetsuperInstr | IStrictequalsInstr | ISubtractInstr | ISubtractIInstr | ISwapInstr | IThrowInstr | ITypeofInstr | IUrshiftInstr;
