import { IClassInfo } from "./classes";
import { IMethodInfo } from "./methods";
import { IQName, MultinameInfo } from "./multiname";
import { INamespaceInfo } from "./namespace";
import { Trait } from "./trait";
export declare enum InstanceInfoFlag {
    ClassSealed = 1,
    ClassFinal = 2,
    ClassInterface = 4,
    ClassProtectedNs = 8
}
export interface IInstanceInfo {
    class: IClassInfo;
    name: IQName;
    supername: MultinameInfo;
    flags: number;
    protectedNs?: INamespaceInfo;
    interfaceCount: number;
    interfaces: MultinameInfo[];
    iinit: IMethodInfo;
    traitCount: number;
    traits: Trait[];
}
