import { INamespaceInfo, INamespaceSetInfo } from "./namespace";
export declare enum MultinameKind {
    QName = 7,
    QNameA = 13,
    RTQName = 15,
    RTQNameA = 16,
    RTQNAmeL = 17,
    RTQNameLA = 18,
    Multiname = 9,
    MultinameA = 14,
    MultinameL = 27,
    MultinameLA = 28,
    TypeName = 29
}
export interface IMultinameInfo {
    kind: MultinameKind;
}
export interface IQName extends IMultinameInfo {
    kind: MultinameKind.QName | MultinameKind.QNameA;
    ns: INamespaceInfo;
    name: string;
}
export interface IRTQName extends IMultinameInfo {
    kind: MultinameKind.RTQName | MultinameKind.RTQNameA;
    name: string;
}
export interface IRTQNameL extends IMultinameInfo {
    kind: MultinameKind.RTQNAmeL | MultinameKind.RTQNameLA;
}
export interface IMultiname extends IMultinameInfo {
    kind: MultinameKind.Multiname | MultinameKind.MultinameA;
    name: string;
    nsSet: INamespaceSetInfo;
}
export interface IMultinameL extends IMultinameInfo {
    kind: MultinameKind.MultinameL | MultinameKind.MultinameLA;
    nsSet: INamespaceSetInfo;
}
export interface ITypeName extends IMultinameInfo {
    kind: MultinameKind.TypeName;
    name: MultinameInfo;
    names: MultinameInfo[];
}
export declare type MultinameInfo = IQName | IRTQName | IRTQNameL | IMultiname | IMultinameL | ITypeName;
